construction_times = {
["ammo-turret"] = 480,
["electric-turret"] = 540,
["fluid-turret"] = 600,
["assembling-machine"] = 180,
["artillery-turret"] = 720,
["furnace"] = 120,
["lab"] = 150,
["mining-drill"] = 60,
["offshore-pump"] = 60,
["pump"] = 60,
["radar"] = 240,
["reactor"] = 720,
["roboport"] = 240,
["rocket-silo"] = 1200,
["solar-panel"] = 90,
["wall"] = 120,
}

TICKS_PER_UPDATE = 10

script.on_init(function()
global.constructing = {}
global.delayed_register = {}
end)
script.on_configuration_changed(function()

end)
script.on_event(defines.events.on_tick, function(event)
	for i, ent in pairs(global.delayed_register) do
		if ent.valid and ent.destructible and ent.minable then
			local time = construction_times[ent.type]
			table.insert(global.constructing, {entity= ent, final_tick = event.tick+time+1, healing = ent.health/2/time*TICKS_PER_UPDATE})
			ent.health = ent.health / 2
			ent.active = false
		end
		global.delayed_register[i] = nil
	end
end)

script.on_nth_tick(TICKS_PER_UPDATE, function(event)
	for i, data in pairs(global.constructing) do
		if data.entity and data.entity.valid then
			data.entity.health = data.entity.health + data.healing
			if event.tick > data.final_tick then
				if data.entity.name:sub(1,17) ~= "realistic-reactor" then
					data.entity.active = true
				end
				global.constructing[i] = nil
			end
		
		else
			global.constructing[i] = nil
		end
	end
end)

local function table_length(tbl)
	local i=0
	for _ in pairs(tbl) do
		i=i+1
	end
	return i
end

function dbg(str)
	if str == nil then
		str = "nil"
	elseif type(str) ~= "string" and type(str) ~= "number" then
		if type(str)=="boolean" then
			if str == true then
				str = "true"
			else
				str = "false" 
			end
		else
			str=type(str)
		end
	end
	game.players[1].print(game.tick.. " "..str)
end

function distance(pos1,pos2)
	local x=(pos1.x-pos2.x)^2
	local y=(pos1.y-pos2.y)^2
	return(x+y)^0.5
end



script.on_event({defines.events.on_robot_built_entity,defines.events.on_built_entity}, function(event)
	if construction_times[event.created_entity.type] then
		table.insert(global.delayed_register, event.created_entity)
	end
end)

script.on_event(defines.events.script_raised_built, function()

end)

script.on_event(defines.events.on_entity_died, function(event)

end)

script.on_event(defines.events.on_trigger_created_entity, function(event)
	if not event.entity then return end
	
end)